/*
 * 创客信息
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.CashModels;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserIdentityController : BaseController
    {
        public UserIdentityController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["CashSqlConnStr"].ToString();
        }

        #region 创客信息列表

        /// <summary>
        /// 根据条件查询创客信息列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserIdentity data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询创客信息列表

        /// <summary>
        /// 创客信息列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserIdentity data, string CheckStatusSelect, string CreateDateData, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("BuddyNo", "1"); //创客编号
            Fields.Add("BuddyName", "1"); //创客名称
            Fields.Add("IdCardNo", "1"); //身份证号
            Fields.Add("UserMobile", "1"); //手机号
            Fields.Add("BankCardNo", "1"); //银行卡号


            string condition = " and Status>-1";
            //验证和同步账户
            if (!string.IsNullOrEmpty(CheckStatusSelect))
            {
                condition += " and CheckStatus=" + CheckStatusSelect;
            }
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and CreateDate>='" + start + " 00:00:00' and CreateDate<='" + end + " 23:59:59'";
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.CashTables).IndexData("UserIdentity", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //验证和同步账户
                int CheckStatus = int.Parse(dic["CheckStatus"].ToString());
                if (CheckStatus == 0) dic["CheckStatus"] = "初始";
                if (CheckStatus == 1) dic["CheckStatus"] = "进件成功";
                if (CheckStatus == 2) dic["CheckStatus"] = "签约成功";
                if (CheckStatus == 3) dic["CheckStatus"] = "进件失败";

            }
            return Json(obj);
        }

        #endregion

        #region 增加创客信息

        /// <summary>
        /// 增加或修改创客信息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加创客信息

        /// <summary>
        /// 增加或修改创客信息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserIdentity data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("BuddyNo", data.BuddyNo); //创客编号
            Fields.Add("BuddyName", data.BuddyName); //创客名称
            Fields.Add("IdCardNo", data.IdCardNo); //身份证号
            Fields.Add("UserMobile", data.UserMobile); //手机号
            Fields.Add("BankCardNo", data.BankCardNo); //银行卡号
            Fields.Add("CertFrontImage", data.CertFrontImage); //身份证正面照
            Fields.Add("CertReverseImage", data.CertReverseImage); //身份证反面照
            Fields.Add("LivingScore", data.LivingScore); //活体得分
            Fields.Add("FaceVideo", data.FaceVideo); //活体视频
            Fields.Add("LivingImage", data.LivingImage); //活体照
            Fields.Add("SignImageUrl", data.SignImageUrl); //签名照片地址
            Fields.Add("CheckStatus", data.CheckStatus); //验证和同步账户

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.CashTables).Add("UserIdentity", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserIdentity", "add");
            cashdb.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改创客信息

        /// <summary>
        /// 增加或修改创客信息信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            UserIdentity editData = cashdb.UserIdentity.FirstOrDefault(m => m.Id == Id) ?? new UserIdentity();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改创客信息

        /// <summary>
        /// 增加或修改创客信息信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserIdentity data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("BuddyNo", data.BuddyNo); //创客编号
            Fields.Add("BuddyName", data.BuddyName); //创客名称
            Fields.Add("IdCardNo", data.IdCardNo); //身份证号
            Fields.Add("UserMobile", data.UserMobile); //手机号
            Fields.Add("BankCardNo", data.BankCardNo); //银行卡号
            Fields.Add("CertFrontImage", data.CertFrontImage); //身份证正面照
            Fields.Add("CertReverseImage", data.CertReverseImage); //身份证反面照
            Fields.Add("LivingScore", data.LivingScore); //活体得分
            Fields.Add("FaceVideo", data.FaceVideo); //活体视频
            Fields.Add("LivingImage", data.LivingImage); //活体照
            Fields.Add("SignImageUrl", data.SignImageUrl); //签名照片地址
            Fields.Add("CheckStatus", data.CheckStatus); //验证和同步账户

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.CashTables).Edit("UserIdentity", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "UserIdentity", "update");
            cashdb.SaveChanges();
            RedisDbconn.Instance.AddList("CashPersonalCreateQueue", data.Id);

            return "success";
        }

        #endregion

        #region 删除创客信息信息

        /// <summary>
        /// 删除创客信息信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserIdentity", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.CashTables).Edit("UserIdentity", Fields, id);
            }
            cashdb.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserIdentity", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.CashTables).Edit("UserIdentity", Fields, id);
            }
            cashdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserIdentity", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.CashTables).Edit("UserIdentity", Fields, id);
            }
            cashdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.CashTables).Sort("UserIdentity", Sort, Id);

            AddSysLog(Id.ToString(), "UserIdentity", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                cashdb.UserIdentity.Add(new UserIdentity()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                cashdb.SaveChanges();
            }
            AddSysLog("0", "UserIdentity", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserIdentity data, string CheckStatusSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("BuddyNo", "1"); //创客编号
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("BuddyName", "1"); //创客名称
            Fields.Add("IdCardNo", "1"); //身份证号
            Fields.Add("UserMobile", "1"); //手机号
            Fields.Add("BankCardNo", "1"); //银行卡号


            string condition = " and Status>-1";
            //验证和同步账户
            if (!string.IsNullOrEmpty(CheckStatusSelect))
            {
                condition += " and CheckStatus=" + CheckStatusSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.CashTables).IndexData("UserIdentity", Fields, "Id desc", "0", 1, 20000, condition, "Remark", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //验证和同步账户
                int CheckStatus = int.Parse(dic["CheckStatus"].ToString());
                if (CheckStatus == 0) dic["CheckStatus"] = "初始";
                if (CheckStatus == 1) dic["CheckStatus"] = "进件成功";
                if (CheckStatus == 2) dic["CheckStatus"] = "签约成功";
                if (CheckStatus == 3) dic["CheckStatus"] = "进件失败";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("Remark", "注释");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserIdentity", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
